# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

Name:           maven-install-plugin
Version:        2.3.1
Release:        2%{?dist}
Summary:        Add artifacts to local repository

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://maven.apache.org/plugins/maven-install-plugin
# svn export http://svn.apache.org/repos/asf/maven/plugins/tags/maven-install-plugin-2.3.1 && tar cjf maven-install-plugin-2.3.1.tar.bz2 maven-install-plugin-2.3.1/
Source0:        %{name}-%{version}.tar.bz2
Source2:        maven-install-plugin-jpp-depmap.xml
Obsoletes:      maven2-plugin-install <= 0:2.0.8
Provides:       maven2-plugin-install = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       maven2
Requires:       jpackage-utils
Requires:       java
Requires:       plexus-digest >= 0:1.0
Requires:       plexus-utils >= 0:1.5.6
BuildRequires:  java-devel
BuildRequires:  maven2
BuildRequires:  maven2-common-poms
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  plexus-digest >= 0:1.0
BuildRequires:  plexus-utils >= 0:1.5.6
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Install Plugin is used during the install phase to add
artifact(s) to the local repository. The Install Plugin
uses the information in the POM (groupId, artifactId,
version) to determine the proper location for the artifact
within the local repository.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%prep
%setup -q
iconv -f UTF16 -t ASCII src/test/resources/unit/install-file-with-pomFile-test/plugin-config.xml > tmpf
tail -n +2 tmpf > src/test/resources/unit/install-file-with-pomFile-test/plugin-config.xml

%build
export MAVEN_OPTS="-Dproject.build.sourceEncoding=UTF-8 -Dfile.encoding=UTF-8"
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{_bindir}/mvn-jpp \
         -e \
         -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
         -Dmaven2.jpp.depmap.file=%{SOURCE2} \
         install javadoc:aggregate 

#        -Dmaven.test.failure.ignore \

%install
rm -rf %{buildroot}

# jars
install -Dpm 644 target/maven-install-plugin-%{version}.jar %{buildroot}%{_javadir}/maven-install-plugin-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
install -Dpm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-maven-install-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-install-plugin %{version} JPP maven-install-plugin

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/maven-install-plugin-%{version}.jar
%{_javadir}*/maven-install-plugin.jar
%{_datadir}/maven2/poms/JPP-maven-install-plugin.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sun May 20 2012 Ralph Apel <r.apel@r-apel.de> 2.3.1-2
- rebuild with corrected maven-plugin-testing-harness

* Sun May 20 2012 Ralph Apel <r.apel@r-apel.de> 2.3.1-1
- 2.3.1

* Mon Sep 19 2011 David Walluck <dwalluck@redhat.com> 2.3-1
- fix for JPP-6

* Tue Sep 28 2010 Hui Wang <huwang@redhat.com> - 2.3-10
- Adjust BRs

* Thu Sep 02 2010 Hui Wang <huwang@redhat.com> - 2.3-9
- Rebuild with maven221
- Add pom.patch

* Wed Jul 21 2010 Hui Wang <huwang@redhat.com> - 2.3-8
- Fixed mavenpomdir
- Updated BRs
- Added depmap.xml

* Fri May 21 2010 Alexander Kurtakov <akurtako@redhat.com> 2.3-7
- BR: plexus-digest.

* Fri May 21 2010 Alexander Kurtakov <akurtako@redhat.com> 2.3-6
- Requires: plexus-digest.

* Wed May 19 2010 Hui Wang <huwang@redhat.com> - 2.3-5
- Added missing BR : maven-shared-reporting-impl

* Wed May 19 2010 Hui Wang <huwang@redhat.com> - 2.3-4
- Added missing obsoletes/provides

* Wed May 19 2010 Hui Wang <huwang@redhat.com> - 2.3-3
- Added missing BR : maven-archiver

* Mon May 17 2010 Hui Wang <huwang@redhat.com> - 2.3-2
- Fixed install -pm 644 pom.xml

* Fri May 14 2010 Hui Wang <huwang@redhat.com> - 2.3-1
- Initial version of the package
